
#ifndef ROOT_TLeafI
#define ROOT_TLeafI

//+SEQ,CopyRight,T=NOINCLUDE.

//////////////////////////////////////////////////////////////////////////
//                                                                      //
// TLeafI                                                               //
//                                                                      //
// A TLeaf for an Integer data type.                                    //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


#ifndef ROOT_TLeaf
//*KEEP,TLeaf,T=C++.
#include "TLeaf.h"
//*KEND.
#endif

class TClonesArray;

class TLeafI : public TLeaf {

protected:
    Int_t       fMinimum;         //Minimum value if leaf range is specified
    Int_t       fMaximum;         //Maximum value if leaf range is specified
    Int_t       *fValue;          //!Pointer to data buffer

public:
    TLeafI();
    TLeafI(const Text_t *name, const Text_t *type);
    virtual ~TLeafI();

    virtual void    Export(TClonesArray *list, Int_t n);
    virtual void    FillBasket(TBuffer &b);
    const Text_t    *GetTypeName() const;
    virtual Int_t   GetMaximum() {return fMaximum;}
    virtual Int_t   GetMinimum() {return fMinimum;}
    Float_t         GetValue(Int_t i=0, TTreeFormula *f=0);
    virtual void   *GetValuePointer() {return fValue;}
    virtual void    Import(TClonesArray *list, Int_t n);
    virtual void    Print(Option_t *option="");
    virtual void    ReadBasket(TBuffer &b);
    virtual void    SetAddress(void *add=0);
    virtual void    SetMaximum(Int_t max) {fMaximum = max;}

    ClassDef(TLeafI,1)  //A TLeaf for an Integer data type.
};

#endif
